-- MIX script
-- integrator
-- vstup je vstup (cokoli)
-- výstup je pro kanál, načítá se hodnota vstupu integrálně.
--
-- TODO init val?
--

local input = {
    {"Input", SOURCE},
    {"Sens", VALUE, 1, 100, 50},
    {"Limit", VALUE, 1, 150, 100},
    {"DZ", VALUE, 1, 100, 5}
}

local output = {"ItgOut"}

local treshold -- nenulové polohy vstupu
local s
local l
local val = 0
local retval = 0 -- navratova hodnota

local function init_func()
end

local function run_func(inp, sens, lim, dz)
    s = 500 / sens
    l = lim * 10.24
    treshold = dz * 10.24
    if (math.abs(inp) > treshold) then
        val = val + inp / s
        val = math.max(-l, val)
        val = math.min(val, l)
    end
    return val
end
return {input = input, output = output, run = run_func, init = init_func}
